//
//  RoomView.swift
//  Deliverable 1
//
//  Created by Sneh Kothari on 19/09/22.
//

import SwiftUI
import RealityKit
import ARKit

struct RoomView: View {
    @Binding var screen: Screens
    @ObservedObject var arWorldMap: RoomMapper

    let arViewContainer: ARWorldViewContainer
    var body: some View {
        if arWorldMap.roomName == "New Room" {
            ZStack {
                arViewContainer
                    .edgesIgnoringSafeArea(.all)
                
                VStack {
                    Spacer()
                    Button(action: {
                        arViewContainer.placeObjectView.session.getCurrentWorldMap{(worldMap, _) in
                            if let map: ARWorldMap = worldMap {
                                do {
                                    try arWorldMap.writeWorldMap(map)
                                } catch{
                                    print(error)
                                }
                            }
                        }
                    }, label: {
                        Text("Save Room")
                    })
                }
            }
        } else {
            ZStack {
                arViewContainer
                    .edgesIgnoringSafeArea(.all)
            }.id(arWorldMap.id)
        }
    }
}




struct RoomView_Previews: PreviewProvider {
    static var previews: some View {
        RoomView(screen: .constant(.NewView), arWorldMap: RoomMapper(), arViewContainer: ARWorldViewContainer(arWorldMap: RoomMapper()))
    }
}
