//
//  ViewCard.swift
//  Deliverable 1
//
//  Created by Sneh Kothari on 19/09/22.
//

import SwiftUI

struct ViewCard: View {
    @ObservedObject var arWorldMap: RoomMapper
    @Binding var screen: Screens

    var rooms: [String] = {
        var r = UserDefaults.standard.stringArray(forKey: "room") ?? []
        r.append("New Room")
        return r
    }()
    var body: some View {
        VStack{
            ForEach(0..<rooms.count){ roomName in
                Card(roomName: rooms[roomName], screen: $screen, arWorldMap: arWorldMap)
            }
            Spacer()
        }
        .onAppear {
            arWorldMap.maxRoomCount = rooms.count
        }
    }
}

struct Card: View {
    var roomName: String
    @Binding var screen: Screens
    @ObservedObject var arWorldMap: RoomMapper

    var body: some View {
        HStack{
            Text(roomName)
                .onTapGesture {
                    screen = .NewView
                    arWorldMap.roomName = roomName
                }
        }
    }
}

struct ViewCard_Previews: PreviewProvider {
    static var previews: some View {
        ViewCard(arWorldMap: RoomMapper(), screen: .constant(.ViewCard))
    }
}
